//+------------------------------------------------------------------+
//|                                                    EQ_Volume.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Blue
#property indicator_color4 Orange
//---- input parameters
extern int       Lenght=560;
extern int       SubPeriod=1;
extern int       LastBar=1;

//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];

bool work=false;
datetime last=0;
double ObrPoint;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
ObrPoint=1/Point;
//---- indicators
if((SubPeriod == PERIOD_M1 )&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_M5 )&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_M15)&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_M30)&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_H1 )&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_H4 )&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_D1 )&&(SubPeriod<Period()) )work=true;
if((SubPeriod == PERIOD_W1 )&&(SubPeriod<Period()) )work=true;

   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);
   SetIndexBuffer(3,Buffer4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----PERIOD_H1
   
//----
   return(0);
  }
  
int iLenght(int SubPeriod,int shift)
{
//return((iHigh(NULL,SubPeriod,shift)-iLow(NULL,SubPeriod,shift))*ObrPoint);
return(MathAbs(iClose(NULL,SubPeriod,shift)-iClose(NULL,SubPeriod,shift+1))*ObrPoint);

}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
/*   int    counted_bars=IndicatorCounted();
//----
   int i=Bars-counted_bars-1;
   int j,k;
   
   for(j=i;j>=0;j--)
   {
   
   }
//*/


if(last!=Time[0])
{
   last=Time[0];
}
else
{
   if(LastBar!=0)return(0);
}


if(work)
{
int i,j,k;
int SummVolume=0;
int predel =Lenght*Period()/SubPeriod;
for(i = 0;i<predel-1;i++)SummVolume+=iLenght(SubPeriod,i+LastBar);
double VolumePerBigBar=(SummVolume+0.0)/Lenght;
//double VolumePerSmollBar=SummVolume/SubPeriod;

i=0;
j=0;
double LocalBigVolume=0;
double LocalSmollVolume=0;
double MyLocalLow;
double MyLocalHigh;
double MyLow;
double MyHigh;
double MyOpen;
double MyClose;
   while(i<Lenght)
   {
      LocalBigVolume+=VolumePerBigBar;
      MyLow=iLow(NULL,SubPeriod,j+LastBar);
      MyHigh=iHigh(NULL,SubPeriod,j+LastBar);
      MyOpen=iOpen(NULL,SubPeriod,j+LastBar);
      while(LocalSmollVolume<LocalBigVolume)
      {
         LocalSmollVolume+=iLenght(SubPeriod,j+LastBar);
         MyLocalLow = iLow(NULL,SubPeriod,j+LastBar);
         MyLocalHigh = iHigh(NULL,SubPeriod,j+LastBar);
         if(MyLow >MyLocalLow )MyLow =MyLocalLow ;
         if(MyHigh<MyLocalHigh)MyHigh=MyLocalHigh;
         j++;
      }      
      MyClose=iClose(NULL,SubPeriod,j+LastBar-1);

      Buffer1[i]=MyLow;
      Buffer2[i]=MyHigh;
      Buffer3[i]=MyOpen;
      Buffer4[i]=MyClose;
      i++;
   }
   
//----

}
   return(0);
  }
//+------------------------------------------------------------------+